Package: jqbr
Title: 'jQuery QueryBuilder' Input for 'Shiny'
Version: 1.0.4
Authors@R: 
    person("Harry", "Fisher", , "harryfisher21@gmail.com", role = c("aut", "cre"))
Description: A highly configurable 'jQuery' plugin offering a simple
    interface to create complex queries/filters in 'Shiny'. The outputted
    rules can easily be parsed into a set of 'R' and/or 'SQL' queries and
    used to filter data. Custom parsing of the rules is also supported.
    For more information about 'jQuery QueryBuilder' see
    <https://querybuilder.js.org/>.
License: MIT + file LICENSE
URL: https://github.com/hfshr/jqbr, https://hfshr.github.io/jqbr/
BugReports: https://github.com/hfshr/jqbr/issues
Imports: htmltools, jsonlite, shiny
Suggests: bslib, packer, testthat (>= 3.0.0)
Config/testthat/edition: 3
Encoding: UTF-8
RoxygenNote: 7.3.2
NeedsCompilation: no
Packaged: 2025-09-09 10:15:33 UTC; root
Author: Harry Fisher [aut, cre]
Maintainer: Harry Fisher <harryfisher21@gmail.com>
Repository: CRAN
Date/Publication: 2025-09-09 12:20:07 UTC
Built: R 4.6.0; ; 2026-04-26 13:40:34 UTC; unix

# jqbr <img src='./docs/assets/img/hex-qbr.png' align="right" height="160" />

![stability-wip](https://img.shields.io/badge/stability-work_in_progress-lightgrey.svg)
![License](https://img.shields.io/badge/license-MIT-green?style=flat-square)
[![R-CMD-check](https://github.com/hfshr/jqbr/workflows/R-CMD-check/badge.svg)](https://github.com/hfshr/jqbr/actions)

Shiny input bindings for [jQuery queryBuilder](https://querybuilder.js.org/index.html).

## Installation

```r
# install.packages("pak")
pak::pak("hfshr/jqbr")

```

## See it in action

The best way to see what this input can do is to checkout the demo Shiny app on shinyapps.io [here](https://harryfish.shinyapps.io/qbr_demo).

Or if you have installed the package, you can run `jqbr::run_jqbr_demo()` to launch the app locally.

## Credits

[jQuery QueryBuilder](https://querybuilder.js.org/) by [\@mistic100](https://github.com/mistic100)

[packer](https://github.com/JohnCoene/packer) by [\@JohnCoene](https://github.com/JohnCoene)

[queryBuilder](https://github.com/harveyl888/queryBuilder) R widget by [\@harveyl888](https://github.com/harveyl888)

library(shiny)
library(jqbr)
library(bslib)


# options(
#     shiny.launch.browser = function(...) .vsc.browser(..., viewer = FALSE),
#     shiny.port = httpuv::randomPort()
# )

invisible(
  lapply(
    list.files("./modules/", full.names = TRUE),
    source
  )
)


ui <- fluidPage(
  theme = bslib::bs_theme(version = "5"),
  useQueryBuilder(bs_version = "5"),
  fluidRow(
    column(
      width = 12,
      h1("QueryBuilder demo"),
      p(
        "This app demonstrates some of the examples from",
        tags$a(
          href = "https://querybuilder.js.org/index.html",
          "https://querybuilder.js.org/index.html"
        ),
        "implemented as R shiny inputs in the {jqbr} package",
      ),
      p(
        "Github repo: ",
        tags$a(
          href = "https://github.com/hfshr/jqbr",
          "https://github.com/hfshr/jqbr"
        ),
      ),
      p(
        "Documentation: ",
        tags$a(
          href = "https://hfshr.github.io/jqbr",
          "https://hfshr.github.io/jqbr"
        )
      )
    )
  ),
  fluidRow(
    column(
      width = 12,
      tabsetPanel(
        tabPanel(
          "Basic",
          basic_builder_ui("basic")
        ),
        tabPanel(
          "Plugins",
          plugin_builder_ui("plugin")
        ),
        tabPanel(
          "Widgets",
          widget_builder_ui("widget")
        ),
        tabPanel(
          "R filters",
          r_builder_ui("r_filters")
        ),
        tabPanel(
          "Advanced",
          advanced_builder_ui("advanced")
        )
      )
    )
  )
)

server <- function(input, output, session) {
  basic_builder_server("basic")
  plugin_builder_server("plugin")
  widget_builder_server("widget")
  r_builder_server("r_filters")
  advanced_builder_server("advanced")
}


shinyApp(ui, server)

rule_output_ui <- function(id) {
  ns <- NS(id)
  tagList(
    tabsetPanel(
      tabPanel(
        "R",
        verbatimTextOutput(ns("r_rules"))
      ),
      tabPanel(
        "SQL",
        verbatimTextOutput(ns("sql_rules"))
      ),
      tabPanel(
        "Rules",
        verbatimTextOutput(ns("rules"))
      )
    )
  )
}

rule_output_server <- function(id, qb_id) {
  moduleServer(id, function(input, output, session) {
    output$rules <- renderPrint({
      qb_id()[["rules"]]
    })
    output$r_rules <- renderPrint({
      qb_id()[["r_rules"]]
    })
    output$sql_rules <- renderPrint({
      qb_id()[["sql_rules"]]
    })
  })
}

filters <- list(
  list(
    id = "name",
    label = "Name",
    type = "string",
    description = "I'm a description!"
  ),
  list(
    id = "category",
    label = "Category",
    type = "integer",
    input = "select",
    values = list(
      "Books",
      "Movies",
      "Music",
      "Tools",
      "Goodies",
      "Clothes"
    ),
    description = "I'm another description!",
    operators = c("equal", "not_equal", "in", "not_in", "is_null", "is_not_null")
  ),
  list(
    id = "in_stock",
    label = "In stock",
    type = "integer",
    input = "radio",
    values = list(
      "Yes",
      "No"
    ),
    operators = c("equal", "not_equal")
  ),
  list(
    id = "price",
    label = "Price",
    type = "double",
    validation = list(
      min = 0,
      step = 0.01
    )
  ),
  list(
    id = "id",
    label = "Identifier",
    type = "string",
    placeholder = "____-____-____",
    operators = c("equal", "not_equal")
  )
)



rules_basic <- list(
  condition = "AND",
  rules = list(
    list(
      id = "price",
      operator = "less",
      value = 10.25
    ),
    list(
      condition = "OR",
      rules = list(
        list(
          id = "category",
          operator = "equal",
          value = "Movies"
        ),
        list(
          id = "category",
          operator = "equal",
          value = "Books"
        )
      )
    )
  )
)



basic_builder_ui <- function(id) {
  ns <- NS(id)
  tagList(
    fluidRow(
      column(
        width = 12,
        h2("Basic builder"),
        p("The example below demontrates a querybuilder with default settings.")
      )
    ),
    fluidRow(
      column(
        width = 6,
        h4("Builder"),
        queryBuilderInput(
          inputId = ns("basic"),
          filters = filters,
          rules = rules_basic,
          return_value = "all"
        ),
      ),
      column(
        width = 6,
        h4("Outputs"),
        rule_output_ui(ns("plugin_output"))
      )
    )
  )
}

basic_builder_server <- function(id) {
  moduleServer(id, function(input, output, session) {
    rule_output <- reactive(input$basic)
    rule_output_server("plugin_output", rule_output)
  })
}

library(shiny)

description <-
  "function(rule) {
    if (rule.operator && ['in', 'not_in'].indexOf(rule.operator.type) !== -1) {
      return 'Use a pipe (|) to separate multiple values with in and not in operators';}}"

# description <- "function(rule) {
#         return 'The description for ' + (rule.operator ? rule.operator.type : 'anything');}"

# class(description) <- "json"

filters <- list(
  list(
    id = "name",
    label = "Name",
    type = "string",
    description = description
  ),
  list(
    id = "carb",
    label = "Carb",
    type = "integer",
    description = description
  ),
  list(
    id = "rate",
    label = "Slider",
    type = "integer",
    validation = list(
      min = 0,
      max = 100
    ),
    plugin = "slider",
    plugin_config = list(
      min = 0,
      max = 100,
      value = 0
    )
  ),
  list(
    id = "date",
    label = "Datepicker",
    type = "date",
    validation = list(
      format = "YYYY/MM/DD"
    ),
    plugin = "datepicker",
    plugin_config = list(
      format = "yyyy/mm/dd",
      todayBtn = "linked",
      todayHighlight = TRUE,
      autoclose = TRUE
    )
  ),
  list(
    id = "state",
    label = "State",
    icon = "glyphicon glyphicon-globe",
    type = "string",
    input = "select",
    multiple = T,
    plugin = "selectize",
    plugin_config = list(
      valueField = "id",
      labelField = "name",
      searchField = "name",
      sortField = "name",
      options = list(
        list(id = "AL", name = "Alabama"),
        list(id = "AK", name = "Alaska"),
        list(id = "AZ", name = "Arizona"),
        list(id = "AR", name = "Arkansas"),
        list(id = "CA", name = "California"),
        list(id = "CO", name = "Colorado"),
        list(id = "CT", name = "Connecticut"),
        list(id = "DE", name = "Delaware"),
        list(id = "DC", name = "District of Columbia"),
        list(id = "FL", name = "Florida"),
        list(id = "GA", name = "Georgia"),
        list(id = "HI", name = "Hawaii"),
        list(id = "ID", name = "Idaho")
      )
    )
  ),
  list(
    id = "category",
    label = "Category",
    type = "integer",
    input = "checkbox",
    values = list(
      "Books",
      "Movies",
      "Music",
      "Tools",
      "Goodies",
      "Clothes"
    ),
    operators = c(
      "equal",
      "not_equal",
      "in",
      "not_in",
      "is_null",
      "is_not_null"
    )
  ),
  list(
    id = "coord",
    label = "Coordinates",
    type = "string",
    input = "function(rule, name) {
      var $container = rule.$el.find('.rule-value-container');

      $container.on('change', '[name='+ name +'_1]', function(){
        var h = '';

        switch ($(this).val()) {
          case 'A':
            h = '<option value=\"-1\">-</option> <option value=\"1\">1</option> <option value=\"2\">2</option>';
            break;
          case 'B':
            h = '<option value=\"-1\">-</option> <option value=\"3\">3</option> <option value=\"4\">4</option>';
            break;
          case 'C':
            h = '<option value=\"-1\">-</option> <option value=\"5\">5</option> <option value=\"6\">6</option>';
            break;
        }

        $container.find('[name$=_2]')
          .html(h).toggle(!!h)
          .val('-1').trigger('change');
      });

      return '\\
      <select name=\"'+ name +'_1\"> \\
        <option value=\"-1\">-</option> \\
        <option value=\"A\">A</option> \\
        <option value=\"B\">B</option> \\
        <option value=\"C\">C</option> \\
      </select> \\
      <select name=\"'+ name +'_2\" style=\"display:none;\"></select>';
    }",
    valueGetter = "function(rule) {
      return rule.$el.find('.rule-value-container [name$=_1]').val()
        +'.'+ rule.$el.find('.rule-value-container [name$=_2]').val();
    }",
    valueSetter = "function(rule, value) {
      if (rule.operator.nb_inputs > 0) {
        var val = value.split('.');

        rule.$el.find('.rule-value-container [name$=_1]').val(val[0]).trigger('change');
        rule.$el.find('.rule-value-container [name$=_2]').val(val[1]).trigger('change');
      }
    }"
  )
)



# rules <- list(
#   rules = list(
#     list(
#       id = "name",
#       operator = "equal",
#       value = "hello"
#     )
#   )
# )

plugins <- list(
  # "sortable" = NULL
  "filter-description" = list("mode" = "inline")
  # "bt-checkbox" = NULL,
  # "invert" = NULL
)
options(
  shiny.launch.browser = function(...) .vsc.browser(..., viewer = FALSE),
  shiny.port = httpuv::randomPort()
)

ui <- fluidPage(
  theme = bslib::bs_theme(version = "5"),
  useQueryBuilder(bs_version = "5"),
  tags$head(
    tags$script(
      "
    $( document ).ready(function() {
    $('#qb').on('afterCreateRuleInput.queryBuilder', function(e, rule) {
  if (rule.filter.plugin == 'selectize') {
    rule.$el.find('.rule-value-container').css('min-width', '200px')
      .find('.selectize-control').removeClass('form-control');
  }
});
});"
    )
  ),
  fluidRow(
    column(
      width = 6,
      queryBuilderInput(
        "qb",
        filters = filters,
        # rules = rules,
        plugins = plugins,
        return_value = "r_rules",
        display_errors = TRUE
      )
    ),
    column(
      width = 4,
      actionButton("update", "Update")
    )
  ),
  fluidRow(
    column(
      width = 6,
      tableOutput("table")
    )
  )
)

server <- function(input, output, session) {
  observe({
    req(input$qb_valid)
    print(input$qb)
  })

  new_rules <- list(
    list(
      id = "go",
      type = "string"
    )
  )

  observe({
    updateQueryBuilder(
      inputId = "qb",
      addFilter = list(
        filter = new_rules
      )
    )
  }) |>
    bindEvent(input$update)

  output$table <- renderTable({
    req(input$qb_valid)
    filter_table(
      data = mtcars,
      filters = input$qb,
      output = "table"
    )
  })



  session$onSessionEnded(function() {
    shiny::stopApp()
  })
}

shinyApp(ui = ui, server = server)

# rsconnect::deployApp(
#   appDir = "./inst/app",
#   appName = "qbr_demo"
# )



library(shiny)

ui <- fluidPage(
  useQueryBuilder(bs_version = "5"),
  queryBuilderInput(
    inputId = "basic",
    filters = filters,
    rules = rules_basic,
    return_value = "r_rules"
  )
)

server <- function(input, output, session) {
  observe({
    print(input$basic)
  })
}


shinyApp(ui, server)

r_filters <- list(
  list(
    id = "mpg",
    title = "MPG",
    type = "double",
    plugin = "slider",
    operators = c("greater", "less", "between"),
    plugin_config = list(
      min = min(mtcars$mpg) - 1,
      max = max(mtcars$mpg) + 1,
      value = 20
    )
  ),
  list(
    id = "cyl",
    type = "integer",
    input = "checkbox",
    values = list(
      4,
      6,
      8
    ),
    operators = c("equal", "not_equal", "in")
  ),
  list(
    id = "disp",
    operators = c("is_na", "is_not_na")
  )
)

rules_r <- list(
  condition = "AND",
  rules = list(
    list(
      id = "mpg",
      operator = "greater",
      value = 20
    ),
    list(
      id = "cyl",
      operator = "in",
      value = 4
    ),
    list(
      id = "disp",
      operator = "is_not_na"
    )
  )
)

r_builder_ui <- function(id) {
  ns <- NS(id)
  tagList(
    fluidRow(
      column(
        width = 12,
        h2("R filter"),
        p(
          "jqbr comes with a helper function",
          tags$code("filter_table"),
          "to automatically apply the output to a table in R"
        )
      )
    ),
    fluidRow(
      column(
        width = 6,
        h4("Builder"),
        queryBuilderInput(
          inputId = ns("r_filter"),
          filters = r_filters,
          return_value = "r_rules",
          display_errors = TRUE,
          rules = rules_r,
          add_na_filter = TRUE
        ),
      ),
      column(
        width = 6,
        h4("Outputs"),
        tableOutput(
          ns("cars")
        )
      )
    )
  )
}

r_builder_server <- function(id) {
  moduleServer(id, function(input, output, session) {
    output$cars <- renderTable({
      filter_table(mtcars, input$r_filter)
    })
  })
}

advanced_filters <- list(
  list(
    id = "coord",
    label = "Coordinates",
    type = "string",
    input = "function(rule, name) {
      var $container = rule.$el.find('.rule-value-container');

      $container.on('change', '[name='+ name +'_1]', function(){
        var h = '';

        switch ($(this).val()) {
          case 'A':
            h = '<option value=\"-1\">-</option> <option value=\"1\">1</option> <option value=\"2\">2</option>';
            break;
          case 'B':
            h = '<option value=\"-1\">-</option> <option value=\"3\">3</option> <option value=\"4\">4</option>';
            break;
          case 'C':
            h = '<option value=\"-1\">-</option> <option value=\"5\">5</option> <option value=\"6\">6</option>';
            break;
        }

        $container.find('[name$=_2]')
          .html(h).toggle(!!h)
          .val('-1').trigger('change');
      });

      return '\\
      <select name=\"'+ name +'_1\"> \\
        <option value=\"-1\">-</option> \\
        <option value=\"A\">A</option> \\
        <option value=\"B\">B</option> \\
        <option value=\"C\">C</option> \\
      </select> \\
      <select name=\"'+ name +'_2\" style=\"display:none;\"></select>';
    }",
    valueGetter = "function(rule) {
      return rule.$el.find('.rule-value-container [name$=_1]').val()
        +'.'+ rule.$el.find('.rule-value-container [name$=_2]').val();
    }",
    valueSetter = "function(rule, value) {
      if (rule.operator.nb_inputs > 0) {
        var val = value.split('.');

        rule.$el.find('.rule-value-container [name$=_1]').val(val[0]).trigger('change');
        rule.$el.find('.rule-value-container [name$=_2]').val(val[1]).trigger('change');
      }
    }"
  )
)


rules_advanced <- list(
  condition = "AND",
  rules = list(
    list(
      id = "coord",
      operator = "equal",
      value = "B.3"
    )
  )
)



advanced_builder_ui <- function(id) {
  ns <- NS(id)
  tagList(
    fluidRow(
      column(
        width = 12,
        h2("Advanced"),
        p(
          "jqbr supports javascript functions to define custom inputs.",
          "Just pass the js function as a string and jqbr will handle the rest!",
          "Based on the example ", tags$a(
            href = "https://querybuilder.js.org/demo.html#widgets",
            "here."
          )
        )
      )
    ),
    fluidRow(
      column(
        width = 6,
        h4("Builder"),
        queryBuilderInput(
          inputId = ns("advanced"),
          filters = advanced_filters,
          rules = rules_advanced,
          return_value = "all"
        )
      ),
      column(
        width = 6,
        h4("Output"),
        rule_output_ui(ns("plugin_output"))
      )
    )
  )
}

advanced_builder_server <- function(id) {
  moduleServer(id, function(input, output, session) {
    rule_output <- reactive(input$advanced)
    rule_output_server("plugin_output", rule_output)
  })
}

widget_filters <- list(
  list(
    id = "date",
    label = "Datepicker",
    type = "date",
    validation = list(
      format = "YYYY/MM/DD"
    ),
    plugin = "datepicker",
    plugin_config = list(
      format = "yyyy/mm/dd",
      todayBtn = "linked",
      todayHighlight = TRUE,
      autoclose = TRUE
    )
  ),
  list(
    id = "rate",
    label = "Slider",
    type = "integer",
    validation = list(
      min = 0,
      max = 100
    ),
    plugin = "slider",
    plugin_config = list(
      min = 0,
      max = 100,
      value = 0
    )
  ),
  list(
    id = "state",
    label = "State",
    type = "string",
    input = "select",
    multiple = TRUE,
    plugin = "selectize",
    plugin_config = list(
      valueField = "id",
      labelField = "name",
      searchField = "name",
      sortField = "name",
      options = list(
        list(id = "AL", name = "Alabama"),
        list(id = "AK", name = "Alaska"),
        list(id = "AZ", name = "Arizona"),
        list(id = "AR", name = "Arkansas"),
        list(id = "CA", name = "California"),
        list(id = "CO", name = "Colorado"),
        list(id = "CT", name = "Connecticut"),
        list(id = "DE", name = "Delaware"),
        list(id = "DC", name = "District of Columbia"),
        list(id = "FL", name = "Florida"),
        list(id = "GA", name = "Georgia"),
        list(id = "HI", name = "Hawaii"),
        list(id = "ID", name = "Idaho")
      )
    )
  )
)


rules_widgets <- list(
  condition = "OR",
  rules = list(
    list(
      id = "date",
      operator = "equal",
      value = "1991/11/17"
    ),
    list(
      id = "rate",
      operator = "equal",
      value = 22
    ),
    list(
      id = "state",
      operator = "equal",
      value = "AL"
    )
  )
)



widget_builder_ui <- function(id) {
  ns <- NS(id)
  tagList(
    tags$head(
      tags$script(
        sprintf(
          "
    $( document ).ready(function() {
    $('#%s').on('afterCreateRuleInput.queryBuilder', function(e, rule) {
  if (rule.filter.plugin == 'selectize') {
    rule.$el.find('.rule-value-container').css('min-width', '200px')
      .find('.selectize-control').removeClass('form-select');
      rule.$el.find('.rule-value-container').find('.selectize-dropdown').removeClass('form-select');
  }});
});",
          ns("widgets")
        )
      )
    ),
    fluidRow(
      column(
        width = 8,
        h2("Widgets"),
        p("jqbr supports all three available widgets for queryBuilder: 'datepicker',
                'slider' and 'selectize'. See them in action below.")
      )
    ),
    fluidRow(
      column(
        width = 6,
        h4("Builder"),
        queryBuilderInput(
          inputId = ns("widgets"),
          filters = widget_filters,
          rules = rules_widgets,
          display_errors = TRUE,
          return_value = "all"
        ),
        fluidRow(
          column(
            width = 12,
            div(
              style = "display: inline-block;",
              actionButton(
                ns("reset"),
                "Reset",
                class = "btn-danger"
              ),
              actionButton(
                ns("set_rules"),
                "Set rules",
                class = "btn-warning"
              )
            )
          )
        )
      ),
      column(
        width = 6,
        h4("Outputs"),
        rule_output_ui(ns("widget_output"))
      )
    )
  )
}


widget_builder_server <- function(id) {
  moduleServer(id, function(input, output, session) {
    rule_output <- reactive(input$widgets)
    rule_output_server("widget_output", rule_output)


    observeEvent(input$reset, {
      updateQueryBuilder(
        inputId = "widgets",
        reset = TRUE
      )
    })

    observeEvent(input$set_rules, {
      updateQueryBuilder(
        inputId = "widgets",
        setRules = rules_widgets
      )
    })
  })
}

plugins <- list(
  "sortable" = NULL,
  "filter-description" = list("mode" = "bootbox"),
  "bt-checkbox" = NULL,
  "invert" = NULL,
  "unique-filter" = NULL,
  "bt-tooltip-errors" = NULL
)
rules_plugins <- list(
  condition = "AND",
  rules = list(
    list(
      id = "name",
      operator = "equal",
      value = "hfshr"
    ),
    list(
      condition = "OR",
      rules = list(
        list(
          id = "category",
          operator = "in",
          value = c("Books", "Movies")
        ),
        list(
          id = "in_stock",
          operator = "equal",
          value = "Yes"
        )
      )
    )
  )
)



plugin_builder_ui <- function(id) {
  ns <- NS(id)
  tagList(
    fluidRow(
      column(
        width = 12,
        h2("Plugins"),
        p(
          "jqbr supports the use of plugins that enhance the builders
                functionality.
                For more information about the plugins see ",
          tags$a(href = "https://querybuilder.js.org/plugins.html", "here")
        )
      )
    ),
    fluidRow(
      column(
        width = 6,
        h4("Builder"),
        queryBuilderInput(
          inputId = ns("plugins"),
          plugins = plugins,
          filters = filters,
          rules = rules_plugins,
          display_errors = TRUE,
          return_value = "all"
        ),
        fluidRow(
          column(
            width = 12,
            div(
              style = "display: inline-block;",
              actionButton(
                ns("reset"),
                "Reset",
                class = "btn-danger"
              ),
              actionButton(
                ns("set_rules"),
                "Set rules",
                class = "btn-warning"
              )
            )
          )
        )
      ),
      column(
        width = 6,
        h4("Outputs"),
        rule_output_ui(ns("plugin_output"))
      )
    )
  )
}

plugin_builder_server <- function(id) {
  moduleServer(id, function(input, output, session) {
    rule_output <- reactive(input$plugins)
    rule_output_server("plugin_output", rule_output)


    observeEvent(input$reset, {
      updateQueryBuilder(
        inputId = "plugins",
        reset = TRUE
      )
    })

    observeEvent(input$set_rules, {
      updateQueryBuilder(
        inputId = "plugins",
        setRules = rules_plugins
      )
    })
  })
}
